//*****************************************************************************************************
//  1. t@C
//		ConvMmeDlg.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		MMEHwlϊ_CAONX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//		
//----------------------------------------------------------------------------------------------------
//  4. 
//		2013.10.22 S.Aizawa VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "MMA_G.h"
#include "ConvMmeDlg.h"
#include "General.h"
#include "GlobalData.h"

// CConvMmeDlg _CAO

IMPLEMENT_DYNAMIC(CConvMmeDlg, CDialog)

CConvMmeDlg::CConvMmeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConvMmeDlg::IDD, pParent)
{
}

CConvMmeDlg::~CConvMmeDlg()
{
}

void CConvMmeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_DATA_FOLDER, m_cEditDataFolder);
	DDX_Control(pDX, IDC_BUTTON_REF, m_cButtonRef);
	DDX_Control(pDX, IDC_BUTTON_CONV, m_cButtonConv);
	DDX_Control(pDX, IDCANCEL, m_cButtonCancel);
	DDX_Control(pDX, IDC_EDIT_START_TIME, m_cEditStartTime);
	DDX_Control(pDX, IDC_EDIT_END_TIME, m_cEditEndTime);
	DDX_Control(pDX, IDC_EDIT_MEAS_TIME, m_cEditMeasTime);
	DDX_Control(pDX, IDC_EDIT_DOWNLINK, m_cEditDownlink);
	DDX_Control(pDX, IDC_EDIT_COMMENT, m_cEditComment);
}


BEGIN_MESSAGE_MAP(CConvMmeDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_REF, &CConvMmeDlg::OnBnClickedButtonRef)
	ON_BN_CLICKED(IDC_BUTTON_CONV, &CConvMmeDlg::OnBnClickedButtonConv)
	ON_EN_UPDATE(IDC_EDIT_DOWNLINK, &CConvMmeDlg::OnEnUpdateEditDownlink)
END_MESSAGE_MAP()

// c[`bv\f[^
static const SToolTipData s_aToolTip[] = {
	{IDC_BUTTON_REF, "_ENf[^݂̑tH_I邽߂̃_CAOJ܂B"},
	{IDC_BUTTON_CONV, "ݒ肳ꂽeŁAHwlϊs܂B"},
	{IDCANCEL, "̃_CAO܂B"},
	{0, NULL}
};

//*****************************************************************************************************
//  1. ֐
//		CConvMmeDlg::ShowDialog
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Hwlϊ_CAO\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDocument	*pDoc		[I] hLgNX|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvMmeDlg::ShowDialog(CDocument *pDoc)
{
	m_pDoc = pDoc;

	if (!m_oMmeFile.ReadIniFile())
		return;

	DoModal();
}

// CConvMmeDlg bZ[W nh

//*****************************************************************************************************
//  1. ֐
//		CConvMmeDlg::OnInitDialog
//----------------------------------------------------------------------------------------------------
//  2. @\
//		_CAO
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUE
//*****************************************************************************************************
BOOL CConvMmeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// c[`bv\ݒ
	CGeneral::SetToolTip(m_tooltip, s_aToolTip, this);

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CConvMmeDlg::OnBnClickedButtonRef
//----------------------------------------------------------------------------------------------------
//  2. @\
//		_ENtH_̎Qƃ{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvMmeDlg::OnBnClickedButtonRef()
{
    BROWSEINFO bInfo;
    LPITEMIDLIST pIDList;
	char buf[_MAX_PATH];
    
	strcpy_s(buf, gDownlinkReferencePath);
    // BROWSEINFO\̂ɒlݒ
    bInfo.hwndOwner             = m_hWnd;		           // _CAO̐eEChẼnh
    bInfo.pidlRoot              = NULL;			           // [gtH_ITEMIDLIST̃|C^ (NULL̏ꍇfXNgbvtH_g܂j
    bInfo.pszDisplayName        = buf;          // IꂽtH_󂯎obt@̃|C^
    bInfo.lpszTitle             = "_ENt@C݃tH_w";				   // c[r[̏㕔ɕ\镶 
    bInfo.ulFlags               = BIF_RETURNONLYFSDIRS;    // \tH_̎ނtO
    bInfo.lpfn                  = BrowseCallbackProc;      // BrowseCallbackProc֐̃|C^
    bInfo.lParam                = (LPARAM)buf;             // R[obN֐ɓnl
    
    // tH_I_CAO\
    pIDList = ::SHBrowseForFolder(&bInfo);
    if(pIDList != NULL){
        // ItemIDListpXɕϊ܂
        if(!::SHGetPathFromIDList(pIDList, buf)){
            // G[
        }

        // ŌpIDList̃|CgĂ郁܂
        ::CoTaskMemFree( pIDList );
		m_cEditDataFolder = buf;

		// .st@C`FbN
		if (!CheckDataFile(buf))
			m_cEditDataFolder = "";
    }

	// ϊ{^L
	EnableConvButton();
}

//*****************************************************************************************************
//  1. ֐
//		CConvMmeDlg::BrowseCallbackProc
//----------------------------------------------------------------------------------------------------
//  2. @\
//		tH_I_CAOR[obN֐
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		HWND		hwnd		[I] EBhEnh
//		UINT		uMsg		[I] CxgbZ[W
//		LPARAM		lParam		[I] Cxgp[^
//		LPARAM		lpData		[I] Cxgf[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		0
//*****************************************************************************************************
int CALLBACK CConvMmeDlg::BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	if (uMsg == BFFM_INITIALIZED)
		::SendMessage(hwnd, BFFM_SETSELECTION, (WPARAM)TRUE, lpData);

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CConvMmeDlg::CheckDataFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ItH_̃`FbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pDataFolder		[I] ItH_
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSE:G[
//*****************************************************************************************************
BOOL CConvMmeDlg::CheckDataFile(LPCTSTR pDataFolder)
{
	CTime oStartTime, oEndTime;
	int nMeasTime;

	if (m_oMmeFile.CheckDataFile(pDataFolder, oStartTime, oEndTime, nMeasTime)) {
		// Jn\
		m_cEditStartTime = oStartTime.FormatGmt("%Y/%m/%d %H:%M:%S");

		// I\
		m_cEditEndTime = oEndTime.FormatGmt("%Y/%m/%d %H:%M:%S");

		// vԕ\
		CString sMeasTime;
		sMeasTime.Format("%dhours  %02dmin  %02dsec", nMeasTime / 3600, nMeasTime / 60 % 60, nMeasTime % 60);
		m_cEditMeasTime = sMeasTime;

		// _EN\
		// Jn̓tftHgŕ\
		m_cEditDownlink = oStartTime.FormatGmt("%Y/%m/%d");

		return TRUE;
	} else
		return FALSE;
}

//*****************************************************************************************************
//  1. ֐
//		CConvMmeDlg::OnBnClickedButtonConv
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Hwlϊ{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvMmeDlg::OnBnClickedButtonConv()
{
	// ϊς݃t@C݃`FbN
	if (m_oMmeFile.m_bOverWrite) {
		if (AfxMessageBox("̕ϊf[^͊ɑ݂܂B̂܂ܕϊsƁCf[^㏑܂B\nϊp܂H",MB_ICONQUESTION|MB_YESNO) == IDNO)
			return;
	}

	// smF
	if (AfxMessageBox("ϊs܂H", MB_YESNO) != IDYES)
		return;

	// ̓f[^Zbg
	m_oMmeFile.m_sDownlink = m_cEditDownlink;
	m_oMmeFile.m_sComment = m_cEditComment;

	// {^𖳌ɂ
	KeyOff();

	// Hwlϊ
	BOOL nResult = m_oMmeFile.ConvDataFile();

	// r[XV
	m_pDoc->UpdateAllViews(NULL);

	if (nResult) {
		// ϊIbZ[W\
		AfxMessageBox("HwlϊI܂", MB_ICONINFORMATION | MB_OK);
	} else {
		// ϊ~bZ[W\
		AfxMessageBox("Hwlϊ𒆎~܂", MB_ICONINFORMATION | MB_OK);
	}

	// {^Lɂ
	KeyOn();
}

//*****************************************************************************************************
//  1. ֐
//		CConvMmeDlg::OnOK
//----------------------------------------------------------------------------------------------------
//  2. @\
//		OK{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvMmeDlg::OnOK()
{
	// ȂiEnterL[ŕȂ悤ɂj
}

//*****************************************************************************************************
//  1. ֐
//		CConvMmeDlg::KeyOff
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ƀ{^GRAYɂ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvMmeDlg::KeyOff(void)
{
	m_cButtonConv.EnableWindow(FALSE);
	m_cButtonCancel.EnableWindow(FALSE);
	m_cButtonRef.EnableWindow(FALSE);
}

//*****************************************************************************************************
//  1. ֐
//		CConvMmeDlg::KeyOn
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^GRAY
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvMmeDlg::KeyOn(void)
{
	EnableConvButton();
	m_cButtonCancel.EnableWindow(TRUE);
	m_cButtonRef.EnableWindow(TRUE);
}

//*****************************************************************************************************
//  1. ֐
//		CConvMmeDlg::EnableConvButton
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Hwlϊ{^̗L^ݒ肷
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvMmeDlg::EnableConvButton()
{
	BOOL bEnable = TRUE;

	// f[^tH_̓`FbN
	if (m_cEditDataFolder.IsEmpty())
		bEnable = FALSE;

	// _EN̓`FbN
	if (m_cEditDownlink.IsEmpty())
		bEnable = FALSE;

	// ϊ{^L^ɐݒ
	m_cButtonConv.EnableWindow(bEnable);
}

//*****************************************************************************************************
//  1. ֐
//		CConvMmeDlg::OnEnUpdateEditDownlink
//----------------------------------------------------------------------------------------------------
//  2. @\
//		_EN̓͏
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvMmeDlg::OnEnUpdateEditDownlink()
{
	EnableConvButton();
}

//*****************************************************************************************************
//  1. ֐
//		CConvMmeDlg::PreTranslateMessage
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhEbZ[W
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		MSG*	pMsg			[I] MSG\̂ւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	eNX̕Ԓl̂܂ܕԂ
//*****************************************************************************************************
BOOL CConvMmeDlg::PreTranslateMessage(MSG* pMsg)
{
	// c[`bv\邽߂̏
	switch(pMsg->message){
	case WM_LBUTTONDOWN:            
	case WM_LBUTTONUP:              
	case WM_MOUSEMOVE:
		if (m_tooltip.m_hWnd)
			m_tooltip.RelayEvent(pMsg);
		break;
	}

	return CDialog::PreTranslateMessage(pMsg);
}
